## rtrlib 0.8.0

=== CMakeLists.txt ===
project(rtrlib C)

set(PROJECT_DESCRIPTION "Lightweight C library that implements the RPKI/RTR protocol and prefix origin validation.")

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=gnu99 -fstack-protector-all")
if(CMAKE_BUILD_TYPE STREQUAL Debug)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Winit-self -Wundef -Wwrite-strings")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat=2 -Werror=missing-prototypes -Werror=missing-declarations")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-format-attribute -Werror=implicit-function-declaration")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=bad-function-cast -Werror=return-type")

    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if(GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfree-nonheap-object")
    endif()

    if(GCC_VERSION VERSION_GREATER 5.1 OR GCC_VERSION VERSION_EQUAL 5.1)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=incompatible-pointer-types")
    endif()

    if(GCC_VERSION VERSION_GREATER 8.0 OR GCC_VERSION VERSION_EQUAL 8.0)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=cast-function-type")
    endif()

    set(DOCS_EXCLUDE_PATTERN "")
else()
    set(DOCS_EXCLUDE_PATTERN "*_private.h")
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

include_directories(.)

add_subdirectory(third-party)

find_package(codecov)

find_package(Threads REQUIRED)
if(NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    find_library(RT_LIB rt)
endif(NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")

include(GNUInstallDirs) # for man page install path

set(RTRLIB_SRC rtrlib/rtr_mgr.c rtrlib/lib/utils.c rtrlib/lib/alloc_utils.c rtrlib/lib/convert_byte_order.c
    rtrlib/lib/ip.c rtrlib/lib/ipv4.c rtrlib/lib/ipv6.c rtrlib/lib/log.c
    rtrlib/pfx/trie/trie.c rtrlib/pfx/trie/trie-pfx.c rtrlib/transport/transport.c
    rtrlib/transport/tcp/tcp_transport.c rtrlib/rtr/rtr.c rtrlib/rtr/packets.c
    rtrlib/spki/hashtable/ht-spkitable.c ${tommyds})
set(RTRLIB_LINK ${RT_LIB} ${CMAKE_THREAD_LIBS_INIT})

include(FindPkgConfig)

if (NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)
    pkg_check_modules(LIBSSH libssh>=0.5.0)

    if(LIBSSH_FOUND)
        # extract version number components
        string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)$" RTRLIB_LIBSSH_VERSION_MATCH ${LIBSSH_VERSION})
        if (NOT RTRLIB_LIBSSH_VERSION_MATCH)
            message(FATAL_ERROR "Could not parse libssh version ${LIBSSH_VERSION}")
        endif(NOT RTRLIB_LIBSSH_VERSION_MATCH)
        SET(LIBSSH_VERSION_MAJOR ${CMAKE_MATCH_1})
        SET(LIBSSH_VERSION_MINOR ${CMAKE_MATCH_2})
        SET(LIBSSH_VERSION_PATCH ${CMAKE_MATCH_3})

        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LIBSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LIBSSH_VERSION_MINOR}")
        set(RTRLIB_HAVE_LIBSSH 1)
        include_directories(${LIBSSH_INCLUDE_DIRS})
        set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
        set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
        message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
    elseif(NOT LIBSSH_FOUND AND RTRLIB_TRANSPORT_SSH)
        message(FATAL_ERROR "libssh >= 0.5.0 not found but ssh support was requested. Omit RTRLIB_TRANSPORT_SSH to build without ssh support.")
    else()
        message(WARNING "libssh >= 0.5.0 not found")
    endif(LIBSSH_FOUND)
endif(NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)

#doxygen target
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doxygen/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/doxygen/Doxyfile @ONLY)

    add_custom_target(doc ALL ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating doxygen API documentation" VERBATIM)
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs DESTINATION share/doc/rtrlib)
endif(DOXYGEN_FOUND)

add_library(rtrlib SHARED ${RTRLIB_SRC})
add_coverage(rtrlib)
target_link_libraries(rtrlib ${RTRLIB_LINK})
set_target_properties(rtrlib PROPERTIES C_VISIBILITY_PRESET hidden)

add_library(rtrlib_static STATIC ${RTRLIB_SRC})
add_coverage(rtrlib_static)
target_link_libraries(rtrlib_static ${RTRLIB_LINK})

ADD_SUBDIRECTORY(tools)

ADD_SUBDIRECTORY(doxygen/examples)

include(AddTest)
ADD_SUBDIRECTORY(tests)
ENABLE_TESTING()
ADD_TEST(test_pfx tests/test_pfx)
ADD_TEST(test_trie tests/test_trie)
#ADD_TEST(test_pfx_locks tests/test_pfx_locks)

ADD_TEST(test_ht_spkitable tests/test_ht_spkitable)
ADD_TEST(test_ht_spkitable_locks tests/test_ht_spkitable_locks)

ADD_TEST(test_live_validation tests/test_live_validation)

ADD_TEST(test_ipaddr tests/test_ipaddr)

ADD_TEST(test_getbits tests/test_getbits)

ADD_TEST(test_dynamic_groups tests/test_dynamic_groups)

#install lib
set (RTRLIB_VERSION_MAJOR 0)
set (RTRLIB_VERSION_MINOR 8)
set (RTRLIB_VERSION_PATCH 0)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h.cmake ${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h)
set(LIBRARY_VERSION ${RTRLIB_VERSION_MAJOR}.${RTRLIB_VERSION_MINOR}.${RTRLIB_VERSION_PATCH})
set(LIBRARY_SOVERSION ${RTRLIB_VERSION_MAJOR})
set_target_properties(rtrlib PROPERTIES SOVERSION ${LIBRARY_SOVERSION} VERSION ${LIBRARY_VERSION} OUTPUT_NAME rtr)
install(TARGETS rtrlib LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/)


# Get lists of all headers
file(GLOB_RECURSE RTRLIB_HEADERS RELATIVE "${PROJECT_SOURCE_DIR}/rtrlib" "rtrlib/*.h")
# Create list of all public headers
foreach(ITEM ${RTRLIB_HEADERS})
    if(NOT ${ITEM} MATCHES ".*_private\\.h" AND NOT ${ITEM} MATCHES ".*tommy.*")
        list(APPEND RTRLIB_PUBLIC_HEADERS ${ITEM})
    endif()
endforeach()

#install includes
foreach(ITEM ${RTRLIB_PUBLIC_HEADERS})
    get_filename_component(HEADER_DIRECTORY "${ITEM}" PATH)
    install(FILES "rtrlib/${ITEM}"
        DESTINATION "include/rtrlib/${HEADER_DIRECTORY}")
endforeach()

#pkgconfig file
if(RTRLIB_TRANSPORT_SSH)
    set (PKG_CONFIG_REQUIRES "libssh >= 0.5.0")
endif(RTRLIB_TRANSPORT_SSH)

# '#include <rtrlib/rtrlib.h>' includes the "rtrlib/"
set (PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
set (PKG_CONFIG_INCLUDEDIR "\${prefix}/include")
set (PKG_CONFIG_LIBS       "-L\${libdir} -lrtr")
set (PKG_CONFIG_CFLAGS     "-I\${includedir}")

configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/pkg-config.pc.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
)
install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)
#add uninstall target
configure_file(
    "cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

coverage_evaluate()

=== tests/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE Debug)

add_executable(test_pfx test_pfx.c)
target_link_libraries(test_pfx rtrlib_static)
add_coverage(test_pfx)
add_executable(test_trie test_trie.c)
target_link_libraries(test_trie rtrlib_static)
add_coverage(test_trie)
add_executable(test_pfx_locks test_pfx_locks.c)
target_link_libraries(test_pfx_locks rtrlib_static)
add_coverage(test_pfx_locks)
add_executable(test_ht_spkitable test_ht_spkitable.c)
target_link_libraries(test_ht_spkitable rtrlib_static)
add_coverage(test_ht_spkitable)
add_executable(test_ht_spkitable_locks test_ht_spkitable_locks.c)
target_link_libraries(test_ht_spkitable_locks rtrlib_static)
add_coverage(test_ht_spkitable_locks)
add_executable(test_live_validation test_live_validation.c)
target_link_libraries(test_live_validation rtrlib_static)
add_coverage(test_live_validation)
add_executable(test_ipaddr test_ipaddr.c)
target_link_libraries(test_ipaddr rtrlib_static)
add_coverage(test_ipaddr)
add_executable(test_getbits test_getbits.c)
target_link_libraries(test_getbits rtrlib_static)
add_coverage(test_getbits)
add_executable(test_dynamic_groups test_dynamic_groups.c)
target_link_libraries(test_dynamic_groups rtrlib_static)
add_coverage(test_dynamic_groups)


if(UNIT_TESTING AND NOT APPLE)
    find_package(CMocka REQUIRED)
    add_subdirectory(unittests)
endif(UNIT_TESTING AND NOT APPLE)

=== third-party/CMakeLists.txt ===
set(tommyds "${CMAKE_CURRENT_SOURCE_DIR}/tommyds/tommy.c" PARENT_SCOPE)

set(mustach "${CMAKE_CURRENT_SOURCE_DIR}/mustach/mustach.c" PARENT_SCOPE)
set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/mustach/mustach.c" PROPERTIES COMPILE_FLAGS "-DNO_EXTENSION_FOR_MUSTACH")

=== tools/CMakeLists.txt ===
add_executable(rtrclient rtrclient.c ${mustach} ${tommyds})
set_source_files_properties("${mustach}" PROPERTIES COMPILE_FLAGS "-DNO_EXTENSION_FOR_MUSTACH -DNO_OPEN_MEMSTREAM")
set_source_files_properties("${tommyds}" PROPERTIES COMPILE_FLAGS "-Dtommy_malloc=malloc -Dtommy_calloc=calloc -Dtommy_realloc=realloc -Dtommy_free=free -include stdlib.h")
target_link_libraries(rtrclient rtrlib)
install(TARGETS rtrclient DESTINATION bin)
install(FILES "rtrclient.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")

add_executable(rpki-rov rpki-rov.c)
target_link_libraries(rpki-rov rtrlib)
install(TARGETS rpki-rov DESTINATION bin)
install(FILES "rpki-rov.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")


set(rtrclient_pfx_templates default csv csvwithheader json)

# Generate escaped string sequence for every template file
# This runs at configure time, changes are not picked up automatically
foreach(template_name IN LISTS rtrclient_pfx_templates)
    file(READ "templates/${template_name}" template_data HEX)
    string(LENGTH "${template_data}" template_length)
    math(EXPR template_length "${template_length} - 1")

    set(TEMPLATES "${TEMPLATES}{ .name = \"${template_name}\", .template = \"")

    foreach(iter RANGE 0 ${template_length} 2)
        string(SUBSTRING ${template_data} ${iter} 2 line)
        set(TEMPLATES "${TEMPLATES}\\x${line}")
    endforeach()
    set(TEMPLATES "${TEMPLATES} \"},\n")

endforeach()

string(STRIP ${TEMPLATES} TEMPLATES)

CONFIGURE_FILE(templates.h.cmake templates.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

=== doxygen/examples/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL Debug)
    if(RTRLIB_HAVE_LIBSSH)
        add_executable(rtr_mgr rtr_mgr.c)
        target_link_libraries(rtr_mgr rtrlib)
        add_executable(ssh_tr ssh_tr.c)
        target_link_libraries(ssh_tr rtrlib_static)
    endif(RTRLIB_HAVE_LIBSSH)
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

=== tests/unittests/CMakeLists.txt ===


add_rtr_unit_test(test_packets_static test_packets_static.c rtrlib_static cmocka)
wrap_functions(test_packets_static lrtr_get_monotonic_time tr_send_all)

add_rtr_unit_test(test_packets test_packets.c rtrlib_static cmocka)
wrap_functions(test_packets rtr_change_socket_state tr_send_all)

=== debian/changelog ===
rtrlib (0.8.0-5) unstable; urgency=medium

  * Adding patch to fix FBTFS with CMake 4 (Closes: #1113196).

 -- Daniel Baumann <daniel@debian.org>  Fri, 26 Sep 2025 13:19:06 +0200

rtrlib (0.8.0-4) unstable; urgency=medium

  * Renaming source package name from librtr to its correct upstream name
    rtrlib.
  * Updating vcs fields.

 -- Daniel Baumann <daniel@debian.org>  Sun, 10 Aug 2025 20:28:14 +0200

librtr (0.8.0-3) experimental; urgency=medium

  * Dropping unneeded build-depends.
  * Switching from pkg-config to pkgconf.
  * Updating to standards version 4.7.2.
  * Updating homepage field.
  * Updating vcs fields.
  * Wrap and sorting debian files.
  * Removing obsolete doc-base.
  * Removing unused gbp.conf.
  * Removin unused salsa-ci.
  * Updating watch file.
  * Reindenting test script.
  * Harmonizing rules file.
  * Renaming and moving patches into debian subdirectory.
  * Rediffing patches.
  * Updating package descriptions.
  * Harmonizing format of copyright.
  * Harmonizing debhelper install files.
  * Harmonizing license headers in copyright.

 -- Daniel Baumann <daniel@debian.org>  Fri, 08 Aug 2025 11:48:27 +0200

librtr (0.8.0-2) experimental; urgency=medium

  * New maintainer (Closes: #1109846).

 -- Daniel Baumann <daniel@debian.org>  Fri, 08 Aug 2025 05:40:01 +0200

librtr (0.8.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062615

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 17:29:44 +0000

librtr (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0.
  * Update Standards-Version, no changes necessary.
  * Refresh patches, drop those merged upstream.
  * Add patch to disable full paths in Doxygen documentation.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 11 Sep 2021 16:43:15 +0200

librtr (0.7.0-1) unstable; urgency=medium

  [ Samuel Henrique ]
  * Team upload.
  * Add salsa-ci.yml.

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Francisco Vilmar Cardoso Ruviaro ]
  * New upstream version 0.7.0.
  * Bump DH level to 13.
  * Bump Standards-Version to 4.5.1.
  * debian/control:
      - Add 'Rules-Requires-Root: no'.
      - Add pkg-config as build dependency.
  * debian/copyright: update upstream and packaging copyright.
  * debian/p/Use-FindPkgConfig-to-search-for-libssh-availability.patch: add.
    Thanks to Marcel Röthke <marcel.roethke@haw-hamburg.de>. (Closes: #975174)
  * debian/rules: drop DEB_LDFLAGS_MAINT_APPEND -Wl,--as-needed,
    because this is default behavior in bullseye toolchain.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Sat, 16 Jan 2021 16:06:05 +0000

librtr (0.6.3-1) unstable; urgency=medium

  * Import new upstream release
    - Fixes build issues with big endian architectures
  * Mark librtr-doc as Multi-Arch: foreign
  * Pass --as-needed to the linker to avoid useless dependencies

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 09 Dec 2018 14:04:06 +0100

librtr (0.6.0-1) unstable; urgency=medium

  * Initial release (Closes: #728206)

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 01 Dec 2018 22:43:01 +0100

=== debian/control ===
Source: rtrlib
Section: libs
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Uploaders:
 David Lamparter <equinox-debian@diac24.net>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen,
 libssh-dev,
 pkgconf,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/rtrlib/rtrlib
Vcs-Browser: https://forgejo.debian.net/frr/rtrlib
Vcs-Git: https://forgejo.debian.net/frr/rtrlib

Package: librtr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 librtr0t64 (= ${binary:Version}),
 libssh-dev,
 ${misc:Depends},
Suggests:
 librtr-doc,
Description: Small extensible RPKI-RTR-Client (development)
 RTRlib implemnts the RPKI/Router Protocol client. The library allows fetching
 and storing validated prefix origin data from a RTR-cache and performs origin
 verification of prefixes. It supports different types of transport sessions
 (e.g., SSH, unprotected TCP) and is easily extendable.
 .
 This package contains development files.

Package: librtr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Small extensible RPKI-RTR-Client (documentation)
 RTRlib implemnts the RPKI/Router Protocol client. The library allows fetching
 and storing validated prefix origin data from a RTR-cache and performs origin
 verification of prefixes. It supports different types of transport sessions
 (e.g., SSH, unprotected TCP) and is easily extendable.
 .
 This package contains the documentation.

Package: librtr0t64
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 librtr0 (<< ${source:Version}),
Replaces:
 librtr0,
Provides:
 ${t64:Provides},
Description: Small extensible RPKI-RTR-Client
 RTRlib implemnts the RPKI/Router Protocol client. The library allows fetching
 and storing validated prefix origin data from a RTR-cache and performs origin
 verification of prefixes. It supports different types of transport sessions
 (e.g., SSH, unprotected TCP) and is easily extendable.

Package: rtr-tools
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Small extensible RPKI-RTR-Client (tools)
 RTRlib implemnts the RPKI/Router Protocol client. The library allows fetching
 and storing validated prefix origin data from a RTR-cache and performs origin
 verification of prefixes. It supports different types of transport sessions
 (e.g., SSH, unprotected TCP) and is easily extendable.
 .
 This package contains additional tools:
 .
   * rtrclient: connects to an RPKI-RTR server and prints protocol information
     and information about the fetched ROAs.
 .
   * rpki-rov: connects to an RPKI-RTR server and allows validating IP prefixes
     and origin ASes.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@}

=== debian/tests/control ===
Tests:
 tools-usage,
Depends:
 rtr-tools,

=== debian/watch ===
version=4
https://github.com/rtrlib/rtrlib/tags .*/v?(\d.*)@ARCHIVE_EXT@
